c
$!
$!	Build the GNU "C++" compiler on VMS
$!   (To try to build with VAX C, replace `gcc' with `cc/noopt'
$!    and delete `cc1_options="-mpcc-alignment"'.
$!    Also add `/sel' after `gcclib/lib' except in the last link.
$!    You also need to get alloca.mar from Bison
$!    and to make definitions for bzero, bcopy and bcmp.)
$!
$!  **************************IMPORTANT**************************
$! Before using, the following directory specs need to be set...
$!
$! work is a directory where all obj files will be put, and the resulting 
$! executable will be put.  Also, the insn-*.* files will be created there
$!
$! gxx_src should be the directory spec of the g++ 1.39 sources.  Write
$! access is not required.
$!
$! gcc_src should point to the directory for the gcc 1.39 sources.  Write
$! access is not required, unless the links have not yet been set up
$! (with config-gcc.com)
$!
$ work    := $diska:[eric.gxx_work]
$ gxx_src := $diska:[eric.g__-1.39.0]
$ gcc_src := $diska:[eric.gcc-1.39]
$!
$!  From here on, things should work automatically.  No user modifications 
$! beyond this point should be required.
$!
$!
$! First we make sure that the directory specs are suitable for a rooted logical
$! name.
$!
$do_work:
$dev = f$parse(work,,,"DEVICE")
$dev1 = f$trnlnm("''dev'"- ":")
$if dev1.eqs."" then goto do_gxx
$if dev1.nes."" then dev = dev1
$work =  dev+f$parse(work,,,"DIRECTORY") - "]["
$goto do_work
$!
$do_gxx:
$dev = f$parse(gxx_src,,,"DEVICE")
$dev1 = f$trnlnm("''dev'"- ":")
$if dev1.eqs."" then goto do_gcc
$if dev1.nes."" then dev = dev1
$gxx_src =  dev+f$parse(gxx_src,,,"DIRECTORY") - "]["
$goto do_gxx
$!
$do_gcc:
$dev = f$parse(gcc_src,,,"DEVICE")
$dev1 = f$trnlnm("''dev'"- ":")
$if dev1.eqs."" then goto done
$if dev1.nes."" then dev = dev1
$gcc_src =  dev+f$parse(gcc_src,,,"DIRECTORY") - "]["
$goto do_gcc
$!
$done:
$l_work    =  work - "]" + ".]"
$l_gxx_src =  gxx_src - "]" + ".]"
$l_gcc_src =  gcc_src - "]" + ".]"
$!
$assign 'l_work'/tran=(conc,term), -
	'l_gxx_src'/tran=(conc,term), -
	'l_gcc_src'/tran=(conc,term) gppp$dir
$!
$!
$set def gppp$dir:[000000]
$!
$if f$search("gppp$dir:[000000]tm.h").eqs."" 
$	then
$	write sys$output "gcc has not been set up first.  Now being done."
$	set def 'gcc_src'
$	@config-gcc
$	set def gppp$dir:[000000]
$	endif
$!
$ set verify
$!
$!	C compiler
$!
$ CC	:=	gcc
$!
$!	Compiler options
$!
$ CFLAGS =	"/debug/cc1_options=""-mpcc-alignment""/inc=(sys$disk:[],[.config])"
$!
$!	Link options
$!
$ LDFLAGS :=	/nomap
$!
$!	Link libraries
$!
$ LIBS :=	gnu_cc:[000000]gcclib/libr,sys$share:vaxcrtl/libr
$!
$ if "''p1'" .eqs. "LINK" then goto Link
$!
$ 'CC 'CFLAGS' RTL.C
$ 'CC 'CFLAGS' OBSTACK.C
$!	Generate insn-flags.h
$ 'CC 'CFLAGS' GENFLAGS.C
$ link/exe=GENFLAGS.EXE genflags,rtl,obstack.obj   ,'LIBS'
$ define/user sys$output insn-flags.h
$ mcr sys$disk:[]genflags md
$!	Generate insn-codes.h
$ 'CC 'CFLAGS' GENCODES.C
$ link/exe=GENCODES.EXE gencodes,rtl,obstack.obj   ,'LIBS'
$ define/user sys$output insn-codes.h
$ mcr sys$disk:[]gencodes md
$!	Generate insn-config.h
$ 'CC 'CFLAGS' GENCONFIG.C
$ link/exe=GENCONFIG.EXE genconfig,rtl,obstack.obj   ,'LIBS'
$ define/user sys$output insn-config.h
$ mcr sys$disk:[]genconfig md
$!
$! current GNU distribution of GCC does not have L_SET,L_XTND defined
$ 'CC 'CFLAGS'/def=(NO_UNISTD_H,"L_SET=0","L_XTND=2") TOPLEV.C
$!
$ t1:='f$search("CPLUS-TAB.C")'
$ if "''t1'" .eqs. "" then goto 10$
$ t1:='f$file_attributes("CPLUS-PARSE.Y","RDT")'
$ t1:='f$cvtime(t1)'
$ t2:='f$file_attributes("CPLUS-TAB.C","RDT")'
$ t2:='f$cvtime(t2)'
$ if t1 .les. t2 then goto 20$
$ 10$:
$! bison /define /verbose /out=cplus-tab.c cplus-parse.y
$! some older versions of bison do not handle the /out= qualifier
$ bison /define /verbose cplus-parse.y
$ rename cplus-parse_tab.c cplus-tab.c
$ rename cplus-parse_tab.h cplus-tab.h
$ 20$:
$ 'CC /cc1_opt="-mpcc-alignment" /inc=([],[.config]) /def=("PARSE_OUTPUT"="""cplus-parse.output""") cplus-tab.c
$!
$ 'CC 'CFLAGS' CPLUS-CADILLAC.C
$ 'CC 'CFLAGS' VERSION.C
$ 'CC 'CFLAGS' TREE.C
$ 'CC 'CFLAGS' PRINT-TREE.C
$ 'CC 'CFLAGS' CPLUS-DECL.C
$ 'CC 'CFLAGS' CPLUS-DECL2.C
$ 'CC 'CFLAGS' CPLUS-TYPECK.C
$ 'CC 'CFLAGS' CPLUS-CVT.C
$ 'CC 'CFLAGS' STOR-LAYOUT.C
$ 'CC 'CFLAGS' FOLD-CONST.C
$ 'CC 'CFLAGS' VARASM.C
$ 'CC 'CFLAGS' EXPR.C
$ 'CC 'CFLAGS' STMT.C
$ 'CC 'CFLAGS' EXPMED.C
$ 'CC 'CFLAGS' EXPLOW.C
$ 'CC 'CFLAGS' OPTABS.C
$ 'CC 'CFLAGS' SYMOUT.C
$ 'CC 'CFLAGS' DBXOUT.C
$ 'CC 'CFLAGS' RTLANAL.C
$ 'CC 'CFLAGS' EMIT-RTL.C
$!
$ 'CC 'CFLAGS' CPLUS-TYPE2.C
$ 'CC 'CFLAGS' CPLUS-TREE.C
$ 'CC 'CFLAGS' CPLUS-LEX.C
$ 'CC 'CFLAGS' CPLUS-CLASS.C
$ 'CC 'CFLAGS' CPLUS-INIT.C
$ 'CC 'CFLAGS' CPLUS-EXCEPT.C
$ 'CC 'CFLAGS' CPLUS-METHOD.C
$ 'CC 'CFLAGS' CPLUS-SEARCH.C
$ 'CC 'CFLAGS' CPLUS-PTREE.C
$ 'CC 'CFLAGS' CPLUS-EXPR.C
$ 'CC 'CFLAGS' CASE.C
$ 'CC 'CFLAGS' SDBOUT.C
$ 'CC 'CFLAGS' GENEMIT.C
$ link/exe=GENEMIT.EXE genemit,rtl,obstack.obj   ,'LIBS'
$ define/user sys$output insn-emit.c
$ mcr sys$disk:[]genemit md
$ 'CC 'CFLAGS' insn-emit.c
$ 'CC 'CFLAGS' INTEGRATE.C
$ 'CC 'CFLAGS' JUMP.C
$ 'CC 'CFLAGS' CSE.C
$ 'CC 'CFLAGS' LOOP.C
$ 'CC 'CFLAGS' FLOW.C
$ 'CC 'CFLAGS' STUPID.C
$ 'CC 'CFLAGS' COMBINE.C
$ 'CC 'CFLAGS' REGCLASS.C
$ 'CC 'CFLAGS' LOCAL-ALLOC.C
$ 'CC 'CFLAGS' GLOBAL-ALLOC.C
$ 'CC 'CFLAGS' RELOAD.C
$ 'CC 'CFLAGS' RELOAD1.C
$ 'CC 'CFLAGS' CALLER-SAVE.C
$ 'CC 'CFLAGS' GENPEEP.C
$ link/exe=GENPEEP.EXE genpeep,rtl,obstack.obj   ,'LIBS'
$ define/user sys$output insn-peep.c
$ mcr sys$disk:[]genpeep md
$ 'CC 'CFLAGS' insn-peep.c
$ 'CC 'CFLAGS' FINAL.C
$ 'CC 'CFLAGS' RECOG.C
$ 'CC 'CFLAGS' GENRECOG.C
$ link/exe=GENRECOG.EXE genrecog,rtl,obstack.obj   ,'LIBS'
$ define/user sys$output insn-recog.c
$ mcr sys$disk:[]genrecog md
$ 'CC 'CFLAGS' insn-recog.c
$ 'CC 'CFLAGS' GENEXTRACT.C
$ link/exe=GENEXTRACT.EXE genextract,rtl,obstack.obj   ,'LIBS'
$ define/user sys$output insn-extract.c
$ mcr sys$disk:[]genextract md
$ 'CC 'CFLAGS' insn-extract.c
$ 'CC 'CFLAGS' GENOUTPUT.C
$ link/exe=GENOUTPUT.EXE genoutput,rtl,obstack.obj   ,'LIBS'
$ define/user sys$output insn-output.c
$ mcr sys$disk:[]genoutput md
$ 'CC 'CFLAGS' insn-output.c
$!
$!
$!	Link it
$!
$ Link:
$ link 'LDFLAGS' /exe=gcc-cc1plus.exe sys$input:/opt,'LIBS'
!
!	"CC1PLUS" Linker options file
!
toplev,cplus-tab,tree,print-tree,cplus-decl,cplus-decl2,cplus-typeck,cplus-type2,stor-layout,fold-const
cplus-tree,cplus-lex,cplus-class,cplus-init,cplus-method,cplus-cvt,cplus-search
cplus-ptree,cplus-except,cplus-expr
varasm,rtl,rtlanal,expr,stmt,case,expmed,explow,optabs,symout,dbxout,emit-rtl,insn-emit
jump,cse,loop,flow,stupid,combine,regclass,local-alloc,global-alloc,reload
reload1,insn-peep,final,recog,insn-recog,insn-extract,insn-output,obstack
integrate,caller-save,cplus-cadillac,version
$!
$!	Done
$!
